﻿Version=6.90
NumberOfForms=1
Form1=frmFileChooser
NumberOfObjects=4
Object1=Node1:Node
Object2=Node2:Node
Object3=node3:Node
Object4=Tree:TreeView
Sub designer
addform(frmFileChooser,"File Chooser","",211,211,211)@
addimagelist(frmfilechooser,IL1,155,65,80,25,2,"folder.bmp","openfolder.bmp",0)@
addimagebutton(frmfilechooser,btnNewFolder,188,245,21,21,"",212,208,200,0,0,0,"cStretchImage","btnNewFolder.bmp",True,True,True,9)@
addimagebutton(frmfilechooser,btnParentFolder,168,245,21,21,"",212,208,200,0,0,0,"cStretchImage","btnParentFolder.bmp",False,True,True,9)@
addbutton(frmfilechooser,btnCancel,94,245,75,21,"Cancel",212,208,200,0,0,0,True,True,9)@
addtextbox(frmfilechooser,txtSelectedFile,5,185,230,22,"",255,255,255,0,0,0,True,True,False,9)@
addarraylist(frmfilechooser,al2,155,35,80,25)@
addcombo(frmfilechooser,cbxFileType,5,215,230,22,"",255,255,255,0,0,0,True,True,0,9)@
addlistbox(frmfilechooser,lbxFileList,5,95,230,80,"",255,255,255,0,0,0,True,True,0,9)@
addbutton(frmfilechooser,btnSelect,20,245,74,21,"Select",212,208,200,0,0,0,True,True,9)@
addarraylist(frmfilechooser,al1,155,5,80,25)@
End Sub
@EndOfDesignText@
' FolderChooser is an example of using the TreeView control.
' The folder nodes are added the first time the user presses on a folder.
' Modyfied by and specci48
' and transformed to FileChooser by klaus
Sub Globals
	Private root As String							: root=""
	Private ReturnTo As String					: ReturnTo=""
	Private needToInitialize As Boolean	: needToInitialize = True
	Private Folder As String						: Folder=""
	Private Folder0 As String						: Folder0=""
	Private Folder1 As String						: Folder1=""
'	Private N1 As String								: N1=""
	Private FName As String							: FName=""
	Private newFolder As String					: newFolder=""
	Private selectedFolder As String		: selectedFolder=""
	Private Filter As String						: Filter=""
	Private FilterI As String						: FilterI=-1
	Private FilterExtNb(10) As String	
	Private FilterExt(10,5) As String		' File extensions of filter
	Private sc As Number								: sc=1 	' scale factor
End Sub

Public Sub Show (ReturnToSub As String,Fold As String,Filt As String)
	Filter=Filt
	If Filter="" Then
'		Filter="All files *.*|*.*"
		Filter=Setup.TextG(20)&" *.*|*.*"
	End If
	If Fold<>"" AND StrLength(Fold)>5 Then
		If StrAt(Fold,StrLength(Fold)-4)<>"." AND StrAt(Fold,StrLength(Fold)-1)<>"\" Then
			Fold=Fold&"\"
		End If
		Folder0=FileDirname(Fold)&"\"
		FName=FileName(Fold)
	Else
		Folder0=""
		FName=""
	End If
	UpdateLanguage
	ReturnTo = ReturnToSub
	InitFilter
	frmFileChooser.Show
	If needToInitialize Then Initialize
	txtSelectedFile.Text=FName
End Sub

Sub Initialize
	sc=Main.Scale
	
	If cPPC=True Then root="\" Else root = SubString(AppPath,0,3)

	tree.new1("frmFileChooser",5*sc,5*sc,230*sc,85*sc)
	tree.AddImage2(IL1.Item(0))
	tree.AddImage2(IL1.Item(1))
	tree.ImageMode = True
	tree.ImageIndex = 0 'sets all nodes to display the folder icon
	tree.SelectedImageIndex = 1 'sets the selcted node (each time) to display the open folder icon
	node1.new1
	node2.new1
	node3.new1
	
	If Folder0<>"" Then
		If StrAt(Folder0,1)=":" Then
			FindFolders(SubString(Folder0,0,2)&"\","tree")
		Else
			FindFolders("\","tree")
		End If
	Else
		FindFolders("\","tree")
	End If

	If Folder0<>"" Then
		OpenFolder
	End If
	needToInitialize = False
End Sub

Sub OpenFolder
	Dim i As Number,a As Number,n1 As String
	
	i=0
	Do
		node1.Value=tree.GetNode(i)
		a=StrIndexOf(Folder0,node1.Text,0)
		If a>-1 Then
			Folder1=SubString(Folder0,0,a+StrLength(node1.Text))&"\"
			tree.SelectedNode=node1.Value
			node1.Expand
			Exit
		End If
		i=i+1
	Loop Until Folder1=Folder0 OR i>=tree.Count
	
	n1=node1.Text
	
	Do 
		OpenSubFolder
	Loop Until Folder1=Folder0
	Folder=Folder0
	InitFileList

End Sub

Sub OpenSubFolder
	Dim i As Number,a As Number
	
	i=0
	Do
		node2.Value=node1.GetNode(i)
		a=StrIndexOf(Folder0,node2.Text,0)
		If a>-1 Then
			Folder1=SubString(Folder0,0,a+StrLength(node2.Text))&"\"
			node1.Value=node2.Value
			tree.SelectedNode=node1.Value
			node1.Expand
			Return
		End If
		i=i+1
	Loop Until Folder1=Folder0 OR i>=node1.Count
End Sub

Sub FindFolders (path As String, Node) 'Finds all folders in a specific path
	WaitCursor(True)
	al1.clear
	DirSearch(al1,path)
	c = StrLength(path)
	For I =0 To al1.count - 1
		s=al1.item(i)
		If Node = "tree" Then
			tree.AddNewNode(SubString(s,c,StrLength(s)-c))
		Else
			Control(Node,Node).AddNewNode (SubString(s,c,StrLength(s)-c))
		End If
	Next
	If Node = "tree" Then
		tree.ExpandAll
	Else
		Control(Node,Node).Expand
	End If
	WaitCursor(False)
End Sub

Sub tree_AfterSelect
	Dim s As String
	
	If tree.action <> "bymouse" AND tree.action <> "unknown" Then Return 'If the event was not raised by the user
'When the user presses on a node, search for all folders inside.
	node2.value = tree.selectednode
	node1.value = tree.selectednode
	node3.value = tree.selectednode

	Do Until IsNull(node2.Value) = True 'Find the full path of the current node
		s = node2.text & "\" & s
		node2.value = node2.parent
	Loop
	selectedFolder = s
	Folder=root & s
	If node3.count = 0 Then 'If it is not 0 then the it was already opened
		FindFolders(Folder,"node1")
	End If
	InitFileList
End Sub

Sub btnSelect_Click
	frmFileChooser.Close
End Sub

Sub frmFileChooser_Close
	Dim s As String

	s=""
	node2.value = tree.selectednode
	Do Until IsNull(node2.value) = True
		s = node2.text & "\" & s
		node2.value = node2.parent
	Loop

	If s="" Then
		CallSub(ReturnTo,cCancel)
	Else If lbxFileList.SelectedIndex=-1 OR lbxFileList.Count=0 Then
		CallSub(ReturnTo,Root & s)
	Else
		CallSub(ReturnTo,Root & s & lbxFileList.Item(lbxFileList.SelectedIndex))
	End If
End Sub

Sub InitFileList
	Dim i As String
	
	al2.Clear
	For i=1 To FilterExtNb(FilterI)
		FileSearch(al2,Folder,FilterExt(FilterI,i))
	Next
	
	lbxFileList.Clear
	For i=0 To al2.Count-1
		lbxFileList.Add(FileName(al2.Item(i)))
	Next
	txtSelectedFile.Text=""

End Sub

Sub lbxFileList_SelectionChanged (Index, Value)
	txtSelectedFile.Text=Value
End Sub

Sub btnParentFolder_Click
	node1.Value = tree.SelectedNode
	If node1.IsRoot=False Then
		node2.Value=node1.Parent
		tree.SelectedNode=Node2.Value
		tree_AfterSelect
	End If
End Sub

Sub btnNewFolder_Click
	If IsNull(tree.SelectedNode) Then
		Msgbox("No parent folder selected", "Selection error", cMsgboxOK, cMsgboxHand)
		Return
	End If
	If StrLength(txtSelectedFile.Text) > 0 Then
	newFolder = root & selectedFolder & txtSelectedFile.Text
	DirCreate(newFolder)
	node1.Value = tree.SelectedNode
	node2.CreateNew(txtSelectedFile.Text)
	node1.AddExisitingNode(node2.Value)
	tree.SelectedNode = node2.Value
	selectedFolder = selectedFolder & txtSelectedFile.Text & "\"
	txtSelectedFile.Text = ""
	txtSelectedFile.Focus
	End If
End Sub

Sub btnCancel_Click
	frmFileChooser.Close
	CallSub(ReturnTo,cCancel)
End Sub

Sub InitFilter
	Dim i As Number,j As Number,k As Number,l As Number,m As Number,n As Number,txt As String
	
	i=0
	j=0
	k=0
	n=0
	cbxFileType.Clear
	
	Do
		l=StrIndexOf(Filter,"|",k)
		If l>-1 Then
			txt=SubString(Filter,k,l-k)
		Else
			txt=SubString(Filter,k,StrLength(Filter)-k)
		End If
		
		If j=0 Then
			cbxFileType.Add(txt)
			j=1
			n=n+1
		Else
			i=0
			If StrIndexOf(txt,",",i)=-1 Then
				FilterExtNb(n)=1
				FilterExt(n,FilterExtNb(n))=txt
			Else
				Do 
					FilterExtNb(n)=FilterExtNb(n)+1
					m=StrIndexOf(txt,",",i)
					If m>-1 Then
						FilterExt(n,FilterExtNb(n))=SubString(txt,i,m-i)
						i=m+1
					Else
						FilterExt(n,FilterExtNb(n))=SubString(txt,i,StrLength(txt)-i)
					End If
				Loop Until m=-1
			End If
			j=0
		End If
		k=l+1
	Loop Until l=-1
	cbxFileType.SelectedIndex=0
End Sub

Sub cbxFileType_SelectionChanged (Index, Value)
	FilterI=Index+1
	InitFileList
End Sub

Sub UpdateLanguage
'	btnSelect.Text="Select"
'	btnCancel.Text="Cancel"
	btnSelect.Text=Setup.TextG(18)
	btnCancel.Text=Setup.TextG(19)
End Sub
